<?php
// $Id: catalog_stuff.inc.php 5140 2012-04-11 15:02:10Z calicant $
//
// funzioni di supporto per catalogo e generazione miniature
//
function make_dir_if_not_exists ($dir) {

    if (!file_exists($dir)) {
        return mkdir($dir, 0700);
    }
    else return 1;
}

function stampa_tenda_catalogo ($name, $currid) {
global $connh, $TABLE_CATALOGO, $WHERE_ADD_GALL, $isAdmin;


    $dbquery = "SELECT id, nome FROM $TABLE_CATALOGO" .  $WHERE_ADD_GALL;
    $elenco_catalogo = $connh->Execute($dbquery) or die("ERROR: $dbquery<br />".$connh->ErrorMsg());

    if (!$elenco_catalogo->RecordCount())
        die("Fatal Error: Sorry, no catalogs for you\n");

    if ($name != 'id_catalogo')
        $actionselect = '';
   else
        $actionselect =
            "onchange = 'document.location.href = \"modules/core/lib/a_foto.php?mode=catalogo&id_catalogo=\" + document.forms.fvisuaopt.id_catalogo.value;'";

    echo "<select class=\"insert_area\" name=\"$name\" $actionselect>\n" . $preopt;

    while (!$elenco_catalogo->EOF) {
        $rowg = $elenco_catalogo->fields;
        $status = $rowg[id] == $currid ? 'selected' : '';
        echo "<option $status value=\"$rowg[id]\">&nbsp;&nbsp;" . $rowg[nome] . "&nbsp;&nbsp;</option>\n";
        $elenco_catalogo->MoveNext();
    } // while
    echo "</select>\n";
}

function delete_catalogo_minia_for_this_image ($file, $gtempname) {
global $MINI_PIC_STRING, $MEDIUM_PIC_STRING, $LARGE_PIC_STRING, $debug;


    $plp = get_catalogo_main_dir();
    $mini_pic = $plp . $gtempname . '/' . $MINI_PIC_STRING . '/' . $file;
    $medium_pic = $plp . $gtempname . '/' . $MEDIUM_PIC_STRING . '/' . $file;
    $large_pic = $plp . $gtempname . '/' . $LARGE_PIC_STRING . '/' . $file;

    if ($debug) {
        echo "delete minia for image $file from catalogo $gtempname<br />";
        echo "mini: $mini_pic<br />\n";
        echo "medium: $medium_pic<br />\n";
        echo "large: $large_pic<br />\n";
    }

    if (file_exists($mini_pic))
        unlink($mini_pic);
    if (file_exists($medium_pic))
        unlink($medium_pic);
    if (file_exists($large_pic))
        unlink($large_pic);
}

function rename_minia ($oldname, $newname, $gtempname) {
global $MINI_PIC_STRING, $MEDIUM_PIC_STRING, $LARGE_PIC_STRING, $debug;

    $plp = get_catalogo_main_dir();
    $mini_pic = $plp . $gtempname . '/' . $MINI_PIC_STRING . '/' . $oldname;
    $medium_pic = $plp . $gtempname . '/' . $MEDIUM_PIC_STRING . '/' . $oldname;
    $large_pic = $plp . $gtempname . '/' . $LARGE_PIC_STRING . '/' . $oldname;

    if (file_exists($mini_pic))
        rename($mini_pic, $plp . $gtempname . '/' . $MINI_PIC_STRING . '/' . $newname);
    if (file_exists($medium_pic))
        rename($medium_pic, $plp . $gtempname . '/' .  $MEDIUM_PIC_STRING . '/' . $newname);
    if (file_exists($large_pic))
        rename($large_pic, $plp . $gtempname . '/' . $LARGE_PIC_STRING . '/' . $newname);
}


function get_image_id_from_name ($img, $gid) {
global $connh, $TABLE_CATALOGO_IMG, $WHERE_ADD_GALL_AND;


    $dbquery = "SELECT id, nome FROM $TABLE_CATALOGO_IMG WHERE gid = '$gid'" . $WHERE_ADD_GALL_AND;
    $rowrs = $connh->Execute($dbquery) or die("ERROR: $dbquery<br />".$connh->ErrorMsg());
    if (!$rowrse->RecordCount())
        die("Fatal Error: Unknown catalogo image name '$img'\n");

    $row = $rowrse->fields;
    return $row[id];
}

function get_catalogo_list_for_this_user () {
global $connh, $TABLE_CATALOGO, $WHERE_ADD_GALL;

    $lista_catalogo = array();

    $dbquery = "SELECT id, nome FROM $TABLE_CATALOGO" . $WHERE_ADD_GALL;
    $rowrs = $connh->Execute($dbquery) or die("ERROR: $dbquery<br />".$connh->ErrorMsg());

    while (!$rowrs->EOF) {
        $row = $rowrs->fields;
        $lista_catalogo[$row[id]] = $row[nome];
        $rowrs->MoveNext();
    } // while

return $lista_catalogo;
}

function get_catalogo_user_from_gid ($gid) {
global $connh, $TABLE_CATALOGO, $WHERE_ADD_GALL_AND;

    $dbquery = "SELECT id, id_user FROM $TABLE_CATALOGO WHERE id = '$gid'" . $WHERE_ADD_GALL_AND;
    $rowrse = $connh->Execute($dbquery) or die("ERROR: $dbquery<br />".$connh->ErrorMsg());

    if (!$rowrse->RecordCount())
        die("Fatal Error: Unknown catalog ID: $gid\n");

    $row = $rowrse->fields;
    return $row[id_user];
}

function get_catalogo_name_from_gid ($gid) {
global $connh, $TABLE_CATALOGO, $WHERE_ADD_GALL_AND;

    $dbquery = "SELECT id, nome FROM $TABLE_CATALOGO WHERE id = '$gid'" . $WHERE_ADD_GALL_AND;
    $rowrse = $connh->Execute($dbquery) or die("ERROR: $dbquery<br />".$connh->ErrorMsg());

    if (!$rowrse->RecordCount())
        die("Fatal Error: Unknown catalog ID: $gid\n");

    $row = $rowrse->fields;
    return $row[nome];
}

//////////////////////// funzioni per la generazione delle miniature

function get_catalogo_main_dir () {
global $priscilla_local_path, $CATALOGO_MAIN_DIR;

    $plp = trim($priscilla_local_path);
    if ($plp{strlen($plp) - 1} != '/')
        $plp .= '/';

    $plp .= $CATALOGO_MAIN_DIR . '/';

return $plp;
}

function makemynewname ($oldfile, $suffix, $basegimage) {

    $oldname = basename($oldfile);

    // si e' deciso che per comodita il nome della miniatura e' il medesimo ;) - cambia la cartella
    $newname = $oldname;
    // se la cartella catalogo che deve contenere la miniatura non esiste, proviamo a crearla
    make_dir_if_not_exists($basegimage . "/" . $suffix);

return $basegimage . "/" . $suffix . "/" . $newname;
} // makemynewname

function get_pix_orientation ($w, $h) {
    return $w >= $h ? 'w' : 'h';
}

function makemyminiature ($imagename, $old_width, $old_height, $w_size, $h_size, $suffix, $basegimage, $mode) {
global $debug;

    $newimagename = makemynewname($imagename, $suffix, $basegimage);

    if ($debug) {
        echo "ow = $old_width, oh = $old_height, nw = $w_size, nh = $h_size, suff = $suffix, basegimage = $basegimage, newimage = $newimagename<br />\n";
        flush();
    }

    if (file_exists($newimagename)) {
        if ($debug)
            echo "cleanup file '$newimagename'<br />\n";
        unlink($newimagename);
    }

    // orientamento orizzonatale
    if (/*$mode != 'fix' || */ get_pix_orientation ($old_width, $old_height) == 'w') {
        if ($debug) {
            if ($mode != 'fix')
                echo "precent mode is ON<br />\n";
            echo "image results horizontal. basesize w = $w_size<br />\n";
        }
        if ($w_size >= $old_width) {
            if ($debug)
                echo "copying for width...<br />";
            if (copy($imagename, $newimagename))
                return 0;
            else return 101;
            }
        $new_width = $w_size;
        $new_height = round (($old_height * $new_width) / $old_width, 0);
    }
    // orientamento verticale
    else {
        if ($debug)
            echo "image results vertical. basesize h = $h_size<br />\n";
        if ($h_size >= $old_height) {
            if ($debug)
                echo "copying for height...<br />";
            if (copy($imagename, $newimagename))
                return 0;
            else return 102;
        }
        $new_height = $h_size;
        $new_width = round (($old_width * $new_height) / $old_height, 0);

    }

    $minia_res = my_resize_image($imagename, $new_width, $new_height, $newimagename);

return $minia_res;
}

function get_from_fix ($size) {

    if (isset($size) && is_numeric($size) && $size > 0)
        return $size;
    else
        return 0;
}

function get_from_percent ($percent, $size) {

    if ($percent <= 0 || $percent > 100)
        return 0;

// calcolo la nuova width
return round (($size * $percent) / 100, 0);
}

// make_mini_pics: ritorna un != 0 in caso di operazione non effettuata
function make_mini_pics ($img, $currid, &$message, $cat_pub=false) {
global $connh, $isAdmin, $UPLOAD_DIR;
global $MINI_PIC_STRING, $MEDIUM_PIC_STRING, $LARGE_PIC_STRING;
global $CATALOGO_MAIN_DIR, $CATALOGO_MAINPIC_DIR;
global $TABLE_CATALOGO, $TABLE_CATALOGO_IMG;
global $debug;
global $catalog_err_no_otiginal_file;

    $message = '';

    // dall'id del catalogo andiamo a prendere proprietario e nome catalogo
    // e altre proprieta'� del catalogo

    $dbquery = "SELECT * FROM $TABLE_CATALOGO WHERE id = '$currid'";
    if (!$isAdmin && $cat_pub == false)
        $dbquery .= " AND id_user = '".$_COOKIE['login']."'";
    $rowrs = $connh->Execute($dbquery) or die("ERROR: $dbquery<br />".$connh->ErrorMsg());
    if (!$rowrs->RecordCount())
        die("Fatal Error: Unable to access to catalog ID = '$currid'\n");
    $row = $rowrs->fields;

    $catalogoname    = $row[nome];
    $scale_method   = $row[method];
    $width_mini     = $row[width_mini];
    $width_medium   = $row[width_medium];
    $width_large    = $row[width_large];

    $height_mini     = $row[height_mini];
    $height_medium   = $row[height_medium];
    $height_large    = $row[height_large];


    // questa un po' pericolosa
    if (!$width_mini || !$width_medium || !$width_large)
        return 0;

    if (!$height_mini || !$height_medium || !$height_large)
        return 0;

    $plp = get_catalogo_main_dir();
    $basegimage = $plp . $catalogoname;

    make_dir_if_not_exists($plp . $catalogoname);
    make_dir_if_not_exists($plp . $catalogoname . '/' . $CATALOGO_MAINPIC_DIR);

    $imagename = $plp . $catalogoname . '/' . $CATALOGO_MAINPIC_DIR . '/' . $img;

    if ($debug)
        echo "imagename = $imagename<br />\n";

    if (!file_exists($imagename)) {
        $message = catalog_err_no_original_file . " '" . $imagename . "'";
        return 5;
    }

    // per ora sono supportate JPG e PNG (identificativo 2 e 3 rispettiivamente)
    // le estensioni GD debbono essere caricate
    $size = getimagesize($imagename);

    if (!$size) {
        $message = catalog_err_all_minipic_fail;
        return 2;
    }
    if (($size[2] == 2 || $size[2] == 3) && my_extension_ok('gd'))
        $resize_enabled = 1;
    else
        $resize_enabled = 0;

    if (!$resize_enabled) {
        $message = catalog_err_all_minipic_fail;
        return 3;
    }

    // dimensioni dell'originale
    $old_width = $size[0];
    $old_height = $size[1];

    if (!$old_width || !$old_height) {
        $message = catalog_err_all_minipic_fail;
        return 4;
    }

    if ($debug)
        echo "i = $imagename, m = $scale_method, mi = $width_mini, me = $width_medium, la = $width_large<br />";

    // richiesta di dimensioni fisse
    if ($scale_method == 'fix') {
        $MINI_W_SIZE        = get_from_fix ($width_mini);
        $MEDIUM_W_SIZE      = get_from_fix ($width_medium);
        $LARGE_W_SIZE       = get_from_fix ($width_large);

        $MINI_H_SIZE        = get_from_fix ($height_mini);
        $MEDIUM_H_SIZE      = get_from_fix ($height_medium);
        $LARGE_H_SIZE       = get_from_fix ($height_large);
    }
    // oppure si sono espresse percentuali
    else {
        $MINI_W_SIZE        = get_from_percent ($width_mini, $old_width);
        $MEDIUM_W_SIZE      = get_from_percent ($width_medium, $old_width);
        $LARGE_W_SIZE       = get_from_percent ($width_large, $old_width);

        $MINI_H_SIZE        = get_from_percent ($height_mini, $old_height);
        $MEDIUM_H_SIZE      = get_from_percent ($height_medium, $old_height);
        $LARGE_H_SIZE       = get_from_percent ($height_large, $old_height);
    }


    // adesso si ridimensiona per davvero: risultato operazione $xxxx_res
    // (!=0 per errore: Cfr. function my_resize_image in lib/util.inc.php)
    $mini_res = -1;
    $medium_res = -1;
    $large_res = -1;

    if ($MINI_W_SIZE && $MINI_H_SIZE)
        $mini_res =
            makemyminiature ($imagename, $old_width, $old_height, $MINI_W_SIZE, $MINI_H_SIZE, $MINI_PIC_STRING, $basegimage, $scale_method);
    if ($MEDIUM_W_SIZE && $MEDIUM_H_SIZE)
        $medium_res =
            makemyminiature ($imagename, $old_width, $old_height, $MEDIUM_W_SIZE, $MEDIUM_H_SIZE, $MEDIUM_PIC_STRING, $basegimage, $scale_method);
    if ($LARGE_W_SIZE && $LARGE_H_SIZE)
        $large_res =
            makemyminiature ($imagename, $old_width, $old_height, $LARGE_W_SIZE, $LARGE_H_SIZE, $LARGE_PIC_STRING, $basegimage, $scale_method);

    $original_size_s = catalog_err_original_size . " (" . $old_width . "x" . $old_height . ")" ."<br />";


    $original_size_s = catalog_err_original_size . " (" . $old_width . "x" . $old_height . ")" ."<br />";

    // eventuali messaggi d'avviso su miniature non create

    if ($mini_res)
        $message .= catalog_err_this_minipic_fail . " \"$MINI_PIC_STRING\" " . $original_size_s;

    if ($medium_res)
        $message .= catalog_err_this_minipic_fail . " \"$MEDIUM_PIC_STRING\" " . $original_size_s;

    if ($large_res)
        $message .= catalog_err_this_minipic_fail . " \"$LARGE_PIC_STRING\" " . $original_size_s;


    if ($debug) {
        echo "mini_res = $mini_res, medium_res = $medium_res, large_res = $large_res<br />\n";
        echo "WIDTH: MINI, MEDIUM, LARGE = $MINI_W_SIZE, $MEDIUM_W_SIZE, $LARGE_W_SIZE --- " .
            "HEIGHT: MINI, MEDIUM, LARGE = $MINI_H_SIZE, $MEDIUM_H_SIZE, $LARGE_H_SIZE<br />\n";
    }

return 0;
}

function regenerate_mini_pics ($gid) {
global $connh, $TABLE_CATALOGO_IMG, $isAdmin;

    set_time_limit(0);

    // andiamo a prendere le immagini a noi note del catalogo voluto
    $dbquery = "SELECT nome FROM $TABLE_CATALOGO_IMG WHERE gid = '$gid'";
    if (!$isAdmin)
        $dbquery .= " AND id_user = '".$_COOKIE['login']."'";
    $elenco_imgs = $connh->Execute($dbquery) or die("ERROR: $dbquery<br />".$connh->ErrorMsg());


    while (!$elenco_imgs->EOF) {
        $row = $elenco_imgs->fields;
        $mediamsg = '';
        $testamessage = catalog_msg_regenerate . " " . $row[nome] . "...<br />\n";
        echo $testamessage;
        flush();
        make_mini_pics ($row[nome], $gid, &$mediamsg);
        if ($mediamsg != '') {
            echo $mediamsg;
            flush();
        }
        $message .= $testamessage . $mediamsg . "<br />";
        $elenco_imgs->MoveNext();
    } // while

    echo "<br />" . catalog_msg_regenerate_done . ".<br />\n";

return $message;
}


?>
