<?
// $Id: links_class.php 5140 2012-04-11 15:02:10Z calicant $

// tabelle usate dal modulo
// e altre variabili globali definite in
// inc/config.inc.php



// codici d'errore ritornati in caso di fallita instanzione
define ("LINKS_ERROR_CODE_CONNH", 1);
define ("LINKS_ERROR_CODE_USER", 2);


class Links {

    var $_lk_connh;
    var $_lk_user;
    var $_lk_error;
    var $_lk_last_error;
    var $statusError;

    function Links ($connh, $user) {

        $this->statusError = 0;
        $this->_lk_connh = $connh;
        $this->_lk_user = $user;
        $this->_lk_error = false;
        $this->_lk_last_error = '';


        if (!isset($connh) || !$connh) {
            $this->statusError = LINKS_ERROR_CODE_CONNH;
            return;
        }

        if (!isset($user) || trim($user) == '') {
            $this->statusError = LINKS_ERROR_CODE_USER;
            return;
        }

    } // Links



    // funzioni private ///////////////////////////////////////////////////


    function _make_tenda ($options, $name, $selected, $form_to_post = "", $actionchange = "", $idelem = "") {

        if (count($options)) {

            if ($form_to_post != "") {
                if ($actionchange == "")
                    $postcmd = "onchange=\"document.forms.$form_to_post.submit();\"";
                else
                    $postcmd = $actionchange;
            }
            else
                $postcmd = "";

            $sres = "<select id=\"$idelem\" $postcmd name=\"" . STATIC_MODULE_NAME . "[$name]\" size=\"1\" class=\"insert_area\">\n";

            foreach ($options as $k=>$v) {
                $is_selected = $k == $selected ? 'SELECTED' : '';
                $sres .= "<option $is_selected value=\"" . $k . "\">" . $v . "</option>\n";
            } // while

            $sres .= "</select>\n";
        } // if

    return $sres;
    } // _make_tenda


    function _output_message ($msg) {
        echo
            "<div class=\"insert_message\" align=\"CENTER\"><strong>" .
            $msg .
            "</strong></div>\n";
    } // _output_message


    function _get_links_type_struct () {

        $predefined_type = array (
            LINKS_TAG_EXTERNAL,
            LINKS_TAG_INTERNAL
        );


        $links_type_a = array();

        $dbquery_t = "SELECT * FROM " . TABLE_LINKS_TYPE . " ORDER BY ID ASC";

        $rowrs = $this->_lk_connh->Execute($dbquery_t) or die("ERROR: $dbquery_t<br />" . $this->_lk_connh->ErrorMsg());

        if (!$rowrs->RecordCount()) {

            $conta  = 0;

            foreach ($predefined_type as $k) {

                $conta++;                

                if ($k == LINKS_TAG_INTERNAL)
                    $s_description = LINKS_PREDEFINED_INTERNAL;
                else
                    $s_description = LINKS_PREDEFINED_EXTERNAL;


                $dbquery = "INSERT INTO " . TABLE_LINKS_TYPE . " (id, type, tclass, description, idimag) " .
                        "VALUES ('$conta', '$k', '$k', '$s_description', '0')";
                $this->_lk_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_lk_connh->ErrorMsg());
            }

            $rowrs = $this->_lk_connh->Execute($dbquery_t) or die("ERROR: $dbquery_t<br />" . $this->_lk_connh->ErrorMsg());
        }

        while (!$rowrs->EOF) {
            $row = $rowrs->fields;

            if ($row[FIELD_LINKS_TYPE] == LINKS_TAG_INTERNAL)
                $linktype = LINKS_INTERNAL;
            else if ($row[FIELD_LINKS_TYPE] == LINKS_TAG_EXTERNAL)
                $linktype = LINKS_EXTERNAL;
            else
                $linktype = $row[FIELD_LINKS_TYPE];

            $links_type_a[$row[FIELD_LINKS_TYPE]] = $linktype . "-" . strtoupper($row[FIELD_LINKS_TCLASS]{0});

            $rowrs->MoveNext();

        } // while


    return $links_type_a;
    } // _get_links_type_struct


    function _is_a_good_id ($pd, &$recinfo, $haveid = 0) {

        if ($haveid)
            $pd['idlist'] = array (0 => $haveid);


        $idlist = $pd['idlist'];

        if (!is_array($idlist) || count($idlist) != 1 || !is_numeric($idlist[0])) {
            $this->_lk_error = true;
            $this->_lk_last_error = LINKS_NEED_A_LINK_SELECT;
            return 0;
        }

        $id = $idlist[0];

        $dbquery = "SELECT * FROM " . TABLE_LINKS_LIST . " WHERE " . FIELD_LINKS_ID . " = '" . $id . "'";

       
        $rowrs = $this->_lk_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_lk_connh->ErrorMsg());

 
        if ($rowrs->RecordCount() != 1) {
            $this->_lk_error = true;
            $this->_lk_last_error = LINKS_LINK_NOT_FOUND . " (ID = $id)";
            return 0;
        }

        $recinfo = $rowrs->fields;

        if ($this->_lk_user != 'superuser' && $recinfo[FIELD_LINKS_OWNER] != $this->_lk_user) {
            $this->_lk_error = true;
            $this->_lk_last_error = LINKS_REMOVE_LINK_ERROR;
            return 0;
        }

    return $id;
    } // _is_a_good_id



    function _is_a_good_type ($pd, &$recinfo, $haveid = 0) {

        if ($haveid)
            $pd['idlist'] = array (0 => $haveid);

        $idlist = $pd['idlist'];


        if (!is_array($idlist) || count($idlist) != 1 || !is_numeric($idlist[0])) {
            $this->_lk_error = true;
            $this->_lk_last_error = LINKS_NEED_A_LINK_TYPE;
            return 0;
        }

        $id = $idlist[0];


        if (($id == 1 || $id == 2) && $haveid) {
            $this->_lk_error = true;
            $this->_lk_last_error = LINKS_REMOVE_PREDEFINED_ERROR;
            return 0;
        }


        $dbquery = "SELECT * FROM " . TABLE_LINKS_TYPE . " WHERE " . FIELD_LINKS_ID . " = '" . $id . "'";
       
        $rowrs = $this->_lk_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_lk_connh->ErrorMsg());

 
        if ($rowrs->RecordCount() != 1) {
            $this->_lk_error = true;
            $this->_lk_last_error = LINKS_TYPE_NOT_FOUND . " (ID = $id)";
            return 0;
        }

        $recinfo = $rowrs->fields;

    return $id;
    } // _is_a_good_type


    function _is_a_good_typename ($typename) {

        if ($typename == '' || $typename == LINKS_INTERNAL || $typename == LINKS_EXTERNAL) {
            $this->_lk_error = true;
            $this->_lk_last_error = LINKS_TYPE_NAME_INVALID . ": '" . $typename . "' ";
            return 0;
        }

    return 1;
    } // _is_a_good_typename


    function _type_exists ($typename) {

        $dbquery = "SELECT id FROM " . TABLE_LINKS_TYPE . " WHERE type = '" . $typename . "'";
        $rowrs =  $this->_lk_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_lk_connh->ErrorMsg());

    return $rowrs->RecordCount();
    } // _type_exists

    function _output_error_message ($errmsg, $notemsg) {

        echo "<br /><div align=\"CENTER\" class=\"insert_message\"><strong>" . $errmsg . "<br />" . $notemsg . "</strong></div><br /><br />";

    } // _output_message
    
    function _output_page_list ($selected, $is_disabled, $currpageid) {

        $sstruct = "";

        if ($is_disabled)
            $sdisabled = "disabled";
        else
            $sdisabled = "";

        $postprefix = STATIC_MODULE_NAME;
        $link_node_name = $postprefix . "["  . FIELD_LINKS_PAGEID . "]";

        $m_no_page_found = LINKS_PUBLIC_PAGE_NOT_FOUND;

        // stampa le pagine pubbliche di questo user oppure tutte (sempre pubbliche) per superuser
        if ($this->_lk_user != 'superuser')
            $add_query = " WHERE id_user = '" . $this->_lk_user . "'";

        $dbquery = "SELECT id, sezione FROM " . PRISCILLA_TABLE_NODE . $add_query . " ORDER BY sezione";
        $rowrs = $this->_lk_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_lk_connh->ErrorMsg());

        if ($rowrs->RecordCount() <= 0) {
            return $m_no_page_found;
        }
        else {

            $sstruct =
                "<select $sdisabled id=\"idpaglist\" class=\"insert_area\" name=\"$link_node_name\" size=\"1\">\n" .
                "<option value=\"0\">" . LINKS_PAGE_NO . "</option>\n";

            while (!$rowrs->EOF) {
                $row = $rowrs->fields;
                $is_selected = $row['id'] == $currpageid ? "selected" : "";
                $sstruct .=  "<option $is_selected value=\"" . $row['id'] . "\">" . $row['sezione'] . "</option>\n";
                $rowrs->MoveNext();
            } // while

            $sstruct .= "</select>\n";
        }

    return $sstruct;
    } // _output_page_list()


    function _get_node_info ($pageid, &$v_url) {


        $l_links_undefined_node = LINKS_UNDEFINED_NODE;
        $v_url = '';

        if (is_numeric($pageid) && $pageid != 0) {

            $dbquery = "SELECT id_user, sezione FROM node WHERE id = '" . $pageid . "'";
            $rowinfo = $this->_lk_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_lk_connh->ErrorMsg());

            if ($rowinfo->RecordCount() != 1)
                $v_url = $l_links_undefined_node;
            else {
                /* un controllo di sezione e' superfluo si tratta solo di navigabilita' del link
                if ($rowinfo->fields('id_user') != $this->_lk_user && $this->_lk_user != 'superuser')
                    $v_url = $l_links_undefined_node;
                */

                    $v_url = $rowinfo->fields('sezione');                                                
            }
        }
        else
            $v_url = $l_links_undefined_node;

        if ($v_url == $l_links_undefined_node)
            return false;
        else
            return true;

    } //_get_node_info


    function _get_tclass ($typename) {

        $dbquery = "SELECT " . FIELD_LINKS_TCLASS . " FROM " . TABLE_LINKS_TYPE . " WHERE " . FIELD_LINKS_TYPE . " = '" . $typename . "'";
        $rowrs = $this->_lk_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_lk_connh->ErrorMsg());

        if ($rowrs->RecordCount() == 1)
            return $rowrs->fields(FIELD_LINKS_TCLASS);
        else
            return LINKS_TAG_UNKNOWN_TCLASS;

    } // _get_tclass

    function _output_tomainpanel () {

        echo
            "<br /><div align=\"center\"><a href=\"" . $_SERVER['PHP_SELF'] . "\">" . LINKS_TO_MAIN_PANEL . "</a></div>\n";

    } // _output_tomainpanel


    function _get_image_tenda ($currpageid) {

        //  solo superuser setta tipi di link
        //  si selezionano le immagini di supeuser


        $link_imagelist_name = STATIC_MODULE_NAME . "[" . FIELD_LINKS_IDIMAG . "]";


        $dbquery = "SELECT id_image, nome, id_user FROM immagini WHERE id_user = 'superuser' ORDER by nome ASC";
        $rowrs = $this->_lk_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_lk_connh->ErrorMsg());

        if ($rowrs->RecordCount()) {

            $sstruct =
                "<select class=\"insert_area\" name=\"$link_imagelist_name\" size=\"1\">\n" .
                "<option value=\"0\">" . LINKS_NONE . "</option>\n";

            while (!$rowrs->EOF) {
                $row = $rowrs->fields;


                $is_selected = $row['id_image'] == $currpageid ? "selected" : "";
                $sstruct .=  "<option $is_selected value=\"" . $row['id_image'] . "\">" . $row['nome'] . "</option>\n";

                $rowrs->MoveNext();
            } // while


            $sstruct .= "</select>\n";

        } // if

    return $sstruct;
    } // _get_image_tenda



    function _build_navigation_panel($position, $position_max, $banner_total, $showlimit) {
       

        $postprefix = STATIC_MODULE_NAME;

        $b_name_init = $postprefix . "[" . "navigation_init" . "]";
        $b_name_forward = $postprefix . "[" . "navigation_forward" . "]";
        $b_name_rewind = $postprefix . "[" . "navigation_rewind" . "]";
        $b_name_end = $postprefix . "[" . "navigation_end" . "]";

 
        $page_total = ceil($banner_total / $showlimit);
        $page_current = floor($position / $showlimit) + 1; 

        if (!$position) {
            $init_disabled = 'DISABLED';
            $rewind_disabled = 'DISABLED';
        }
        else {
            $init_disabled = '';
            $rewind_disabled = '';          
        }


        if ($position == $position_max) {
            $end_disabled = 'DISABLED';
            $forward_disabled = 'DISABLED';
        }
        else {
            $end_disabled = '';
            $forward_disabled = '';         
        }

        return
            "<input class=\"button_in awesome\" $init_disabled type=\"SUBMIT\" name=\"$b_name_init\" id=\"$b_name_init\" value=\"<<\">" . "&nbsp;" .
            "<input class=\"button_in awesome\" $forward_disabled type=\"SUBMIT\" name=\"$b_name_forward\" id=\"$b_name_forward\" value=\">\">" . "&nbsp;" .
            "<input class=\"button_in awesome\" $rewind_disabled type=\"SUBMIT\" name=\"$b_name_rewind\" id=\"$b_name_rewind\" value=\"<\">" . "&nbsp;" .
            "<input class=\"button_in awesome\" $end_disabled type=\"SUBMIT\" name=\"$b_name_end\" id=\"$b_name_end\" value=\">>\">" . "&nbsp;" .
            LINKS_PAG . " $page_current / $page_total";
    } // _build_navigation_panel



    ////////////////////////////////////////// // funzioni di output pannelli
    function outputMainPanel ($postdata) {

/*
        echo "<pre>";
        PRINT_R($postdata);
        echo "</pre>";
*/

        $postprefix = STATIC_MODULE_NAME;
        $l_title_link_list = LINKS_LIST;
        $l_title_orderby = LINKS_ORDER_BY;

        $l_links_id = LINKS_ID;
        $l_links_url = LINKS_URL_ID;
        $l_links_padeid = LINKS_PAGE_ID;
        $l_links_description = LINKS_DESCRIPTION;
        $l_links_linktext = LINKS_TEXT;
        $l_links_target = LINKS_TARGET;
        $l_links_type = LINKS_LINK_TYPE;
        $l_links_hits = LINKS_HITS;
        $l_links_visibility = LINKS_VIISBILITY;
        $l_links_owner = LINKS_OWNER;
        $l_showlimit = LINKS_LINK_PER_PAGE;

        $b_links_remove = LINKS_REMOVE_SELECTED_LINK;
        $b_links_modify = LINKS_EDIT_SELECTED_LINK;
        $b_links_groupadmin = LINKS_ADMINISTRATION;

        $b_name_remove = $postprefix . "[" . LINKS_BUTTON_LINK_REMOVE . "]";
        $b_name_modify = $postprefix . "[" . LINKS_BUTTON_LINK_MODIFY . "]";
        $b_name_groupadmin = $postprefix . "[" . LINKS_BUTTON_LINK_GROUPADMIN . "]";

        $comefromname = $postprefix . "[comefrom]";

        $position_name = $postprefix . "[" . "position" . "]";
        $showlimit_name = $postprefix . "[" . "showlimit" . "]";

        $cb_links_selected = $postprefix . "[idlist][]";

        $field_list = array (
            "id" => $l_links_id,
            "url" => $l_links_url,
            "type" => $l_links_type,
            "target" => $l_links_target,
            "hits" => $l_links_hits,
            "visibility" => $l_links_visibility,
            "owner" => $l_links_owner
        );


        $limit_list = array (
            0 => LINKS_ALL_LINKS,
            1 => 1,
            2 => 2,
            3 => 3,
            4 => 4,
            5 => 5,
            10 => 10,
            15 => 15,
            20 => 20,
            30 => 30,
            50 => 50
        );
    

        $tenda_visibility = $this->_make_tenda (
            array(
                LINKS_TAG_ALL => LINKS_ALL_LINKS_LOWER,
                LINKS_TAG_PRIVATE  => LINKS_TYPE_PRIVATE,
                LINKS_TAG_PUBLIC => LINKS_TYPE_PUBLIC
            ), LINKS_TAG_VISIBILITY_LIST, $postdata[LINKS_TAG_VISIBILITY_LIST], "flinklist"
        );

        $tenda_orderby = $this->_make_tenda($field_list, LINKS_TAG_ORDERBY, $postdata[LINKS_TAG_ORDERBY], "flinklist");
        $tenda_orderversus = $this->_make_tenda(array("ASC" => LINKS_ORDER_ASCENDING, "DESC" => LINKS_ORDER_DESCENDING), LINKS_TAG_ORDERVERSUS, $postdata[LINKS_TAG_ORDERVERSUS], "flinklist");
 
        $nfield = 8 + 1;


        $prequery_count = "SELECT COUNT(id) AS links_total FROM ";
        $prequery_list = "SELECT * FROM  ";

        $add_query = "";

        if ($this->_lk_user != 'superuser')
            $add_query = " WHERE owner = '" . $this->_lk_user . "'";


        if ($postdata[LINKS_TAG_VISIBILITY_LIST] != LINKS_TAG_ALL) {
            if ($add_query == "")
                $add_query = " WHERE ";
            else
                $add_query .= " AND ";

            $add_query .= FIELD_LINKS_VISIBILITY . " = '" . $postdata[LINKS_TAG_VISIBILITY_LIST] . "'";
        }
        else {
            if ($this->_lk_user != 'superuser')
                $add_query .= " OR " . FIELD_LINKS_VISIBILITY . " = '" . "public" . "'";
        }
  
        $add_query = TABLE_LINKS_LIST . $add_query;

        $query_order .= " ORDER BY " . $postdata[LINKS_TAG_ORDERBY] .  " " . $postdata[LINKS_TAG_ORDERVERSUS];

        $dbquery = $prequery_count .  $add_query;
        $rowrs = $this->_lk_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_lk_connh->ErrorMsg());
        $links_total = $rowrs->fields('links_total');


        if ($links_total)
            $s_links_total = "(" . LINKS_TOTAL . ": $links_total)"; 

        // eventuali spostamenti

        if ($postdata['showlimit']) {
            $position_mod = ($links_total % $postdata['showlimit']);
            $position_max = $links_total - $position_mod;
            
            if (!$position_mod)
                $position_max -= $postdata['showlimit'];

            if (isset($postdata['navigation_init']))
                $postdata['position'] = 0; 
            else if (isset($postdata['navigation_forward']))
                 $postdata['position'] += $postdata['showlimit'];   
            else if (isset($postdata['navigation_rewind']))
                 $postdata['position'] -= $postdata['showlimit'];   
            else if (isset($postdata['navigation_end']))
                $postdata['position'] = $position_max;

            // aggiustamenti
            if ($postdata['position'] < 0)
                $postdata['position'] = 0;

            if ($postdata['position'] > $position_max)
                $postdata['position'] = $position_max;
        }

        if ($postdata['showlimit'] && $links_total > $postdata['showlimit']) {
            $navigation_panel_s =
                $this->_build_navigation_panel($postdata['position'], $position_max, $links_total, $postdata['showlimit']);
            $query_limit = " LIMIT $postdata[position], $postdata[showlimit]";    
        } else {
            $navigation_panel_s = '';
            $query_limit = '';
        }


        $dbquery = $prequery_list . $add_query . $query_order . $query_limit;

//        echo "debug query: " . $dbquery . "<br />";

        $rowrs = $this->_lk_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_lk_connh->ErrorMsg());    


        $tenda_limit = $this->_make_tenda (
            $limit_list,
            "showlimit",
            $postdata['showlimit'],
            "flinklist"
        );


echo <<< END
        <form name="flinklist" action="$_SERVER[PHP_SELF]" method="POST">
        <input type="hidden" name="$position_name" id="$position_name" value="$postdata[position]">
        <input type="hidden" name="$showlimit_name" id="$showlimit_name" value="$postdata[showlimit]">

        <input type="hidden" name="$comefromname" id="$comefromname" value="linkslist">

        <table class="table_border" width="
END;
        include(PRISCILLA_LOCAL_PATH . "adm/include/dim_all.inc.php");
        
echo <<< END
        " align="CENTER" cellpadding="3" cellspacing="1" border="0">

        <tr>
        <th colspan="$nfield" class="table_tit" align="CENTER">
        $l_title_link_list
        </th>
        </tr>

        <tr>
        <th colspan="$nfield" class="table_tit" align="CENTER">
        $l_links_visibility:&nbsp;$tenda_visibility&nbsp;$l_title_orderby:&nbsp;$tenda_orderby&nbsp;$tenda_orderversus&nbsp;
        $l_showlimit&nbsp;$tenda_limit&nbsp;$navigation_panel_s
        </th>
        </tr>

        <tr>
        <td width="5%" align="CENTER" class="table_tit">
        $l_links_id
        </td>
        <td align="CENTER" class="table_tit">
        $l_links_url
        </td>
        <td  align="CENTER" class="table_tit">
        $l_links_linktext
        </td>
        <td align="CENTER" class="table_tit">
        $l_links_type
        </td>
        <td align="CENTER" class="table_tit">
        $l_links_target
        </td>
        <td align="CENTER" class="table_tit">
        $l_links_hits
        </td>
        <td align="CENTER" class="table_tit">
        $l_links_visibility
        </td>
        <td align="CENTER" class="table_tit">
        $l_links_owner
        </td>
        <td align="CENTER" class="table_tit">
        &nbsp;
        </td>
        </tr>
END;


        if ($this->_lk_user == 'superuser')
            $link_admin_button =
                "<input type=\"submit\" value=\"&nbsp;&nbsp;&nbsp;$b_links_groupadmin&nbsp;&nbsp;&nbsp;\" name=\"$b_name_groupadmin\" id=\"$b_name_groupadmin\" class=\"button_in awesome\">&nbsp;&nbsp;&nbsp;";
        else
            $link_admin_button = "";
 

    if ($rowrs->RecordCount()) {

        while (!$rowrs->EOF) {

            $row = $rowrs->fields;

            $v_id = $row[FIELD_LINKS_ID];

            $currentlink_tclass = $this->_get_tclass($row[FIELD_LINKS_TYPE]);


            if ($currentlink_tclass == LINKS_TAG_UNKNOWN_TCLASS)
                $v_url = LINKS_UNKNOWN_LINK_CLASS;
            else if ($currentlink_tclass == LINKS_TAG_INTERNAL) {

                $pageid = $row[FIELD_LINKS_PAGEID];
                $this->_get_node_info ($pageid, $v_url_temp);
                $real_url = "../index.php?id=$pageid";
            }
            else {
                $v_url_temp = $row[FIELD_LINKS_URL];
                $real_url = $v_url_temp;
            }


            $v_description = $row[FIELD_LINKS_DESCRIPTION];

            $v_url = "<a target=\"_blank\" title=\"$v_description\"  href=\"$real_url\">" . $v_url_temp . "</a>";

            $v_linktext = $row[FIELD_LINKS_LINKTEXT];
            
            if ($row[FIELD_LINKS_TYPE] == LINKS_TAG_EXTERNAL)
                $v_type = LINKS_EXTERNAL;
            else if ($row[FIELD_LINKS_TYPE] == LINKS_TAG_INTERNAL)
                $v_type = LINKS_INTERNAL ;
            else
                $v_type = $row[FIELD_LINKS_TYPE];


            $v_target = $row[FIELD_LINKS_TARGET];
            $v_hits = $row[FIELD_LINKS_HITS];
            $v_visibility = $row[FIELD_LINKS_VISIBILITY] == LINKS_TAG_PUBLIC ? LINKS_TYPE_PUBLIC : LINKS_TYPE_PRIVATE;
            $v_owner = $row[FIELD_LINKS_OWNER];

            if ($this->_lk_user == 'superuser' || (trim($this->_lk_user) != '' && $this->_lk_user == $v_owner))
                $s_selected = "<input name=\"$cb_links_selected\" id=\"$cb_links_selected\" class=\"insert_area\" type=\"CHECKBOX\" value=\"$row[id]\">";
            else
                $s_selected = "&nbsp;";


echo <<< END
        <tr>
        <td width="5%" align="CENTER" class="table_id">
        $v_id
        </td>
        <td align="CENTER" class="table_sez">
        $v_url
        </td>
        <td  align="CENTER" class="table_sez">
        $v_linktext
        </td>
        <td align="CENTER" class="table_sez">
        $v_type&nbsp;
        </td>
        <td align="CENTER" class="table_sez">
        $v_target
        </td>
        <td align="CENTER" class="table_sez">
        $v_hits
        </td>
        <td align="CENTER" class="table_sez">
        $v_visibility
        </td>
        <td align="CENTER" class="table_sez">
        $v_owner
        </td>
        <td align="CENTER" class="table_sez">
        $s_selected
        </td>
        </tr>
END;

            $rowrs->MoveNext();
        } // while



echo <<< END
        <tr>
        <td colspan="$nfield" align="CENTER" class="button_out">
        $link_admin_button
        <input type="submit" value="&nbsp;&nbsp;&nbsp;$b_links_modify&nbsp;&nbsp;&nbsp;" name="$b_name_modify" id="$b_name_modify" class="button_in awesome">
        &nbsp;&nbsp;&nbsp;
        <input type="submit" value="&nbsp;&nbsp;&nbsp;$b_links_remove&nbsp;&nbsp;&nbsp;" name="$b_name_remove" id="$b_name_remove" class="button_in awesome">
        </td>
        </tr>
END;

    }



if (!$rowrs->RecordCount() && $link_admin_button != "") {
    echo
    "<tr>\n" .
    "<td colspan=\"$nfield\" align=\"CENTER\" class=\"button_out\">\n" .
    $link_admin_button .
    "</td>\n" .
    "</tr>\n";
}
    echo "</table>\n</form>\n";


    if (!$rowrs->RecordCount())
        echo $this->_output_message(LINKS_NO_LINKS);
    
} // outputMainPanel


    function outputAddLink ($postdata) {

        $postprefix = STATIC_MODULE_NAME;

        if (isset($postdata[LINKS_BUTTON_LINK_MODIFY])) {
            if (!($id = $this->_is_a_good_id($postdata, $recinfo))) {
                $this->outError();
                return;                
            }
            $url_default =  $recinfo[FIELD_LINKS_URL];
            $linktext_default = $recinfo[FIELD_LINKS_LINKTEXT];
            $description_default = $recinfo[FIELD_LINKS_DESCRIPTION];
            $descpos_default = $recinfo[FIELD_LINKS_DESCPOS];
            $visibility_default = $recinfo[FIELD_LINKS_VISIBILITY];
            $type_default = $recinfo[FIELD_LINKS_TYPE];
            $target_default = $recinfo[FIELD_LINKS_TARGET];
            $anchor_default = $recinfo[FIELD_LINKS_ANCHOR];

            $comefrom = OP_LINKS_LINK_MODIFY_SAVE;
            $b_links_action_do = LINKS_BUTTON_SAVE;
            $b_links_action_do_name = $postprefix . "[" . LINKS_BUTTON_LINK_MODIFY_SAVE . "]";

            $hiddenidname = $postprefix . "[" . FIELD_LINKS_ID . "]";
            $hidden_id_info="<input type=\"hidden\" name=\"$hiddenidname\" id=\"$hiddenidname\" value=\"$id\">";

            $b_links_action_cancel = LINKS_BUTTON_CANCEL;
            $b_links_action_cancel_name = $postprefix . "[" . LINKS_BUTTON_LINK_CANCEL . "]";

            $b_links_cancel_info = "&nbsp;&nbsp;<input type=\"submit\" value=\"&nbsp;&nbsp;&nbsp;$b_links_action_cancel&nbsp;&nbsp;&nbsp;\" name=\"$b_links_action_cancel_name\" id=\"$b_links_action_cancel_name\" class=\"button_in awesome\">&nbsp;&nbsp;";

            $l_title = LINKS_EDIT_LINK_PREFS . " (ID = $id)";
            $currpageid = $recinfo[FIELD_LINKS_PAGEID];
            $pageid_is_disabled = $currpageid == 0;
        }
        else {
            $url_default = "";
            $linktext_default = "";
            $description_default = "";
            $descpos_default = "";
            $visibility_default = LINKS_TAG_PUBLIC;
            $type_default = "";
            $target_default = "";
            $comefrom = OP_LINKS_LINK_ADD;
            $b_links_action_do = LINKS_LINK_ADD;
            $b_links_action_do_name = $postprefix . "[" . LINKS_BUTTON_LINK_ADD . "]";
            $b_links_cancel_info = "";
            $l_title = LINKS_LINK_CREATE;
            $currpageid = 0;
            $pageid_is_disabled = true;
            $hidden_id_info = "";
        }

        $url_is_disabled = ! $pageid_is_disabled;
        $s_url_disabled = $url_is_disabled ? "disabled" : "";


        $l_links_id = LINKS_ID;
        $l_links_url = LINKS_LINK_URL;
        $l_links_linktext = LINKS_TEXT;
        $l_links_description = LINKS_DESCRIPTION;
        $l_links_target = LINKS_TARGET;
        $l_links_type = LINKS_LINK_TYPE;
        $l_links_hits = LINKS_HITS;
        $l_links_visibility = LINKS_VIISBILITY;
        $l_links_owner = LINKS_OWNER;
        $l_links_anchor = LINKS_ANCHOR;

        $comefromname = $postprefix . "[comefrom]";
        $urlname = $postprefix . "[url]";
        $linktextname = $postprefix . "[linktext]";
        $descname = $postprefix . "[description]";

        $visibilitylistname = $postprefix . "[" . LINKS_TAG_VISIBILITY_LIST . "]"; 
        $orderbyname = $postprefix . "[" . LINKS_TAG_ORDERBY . "]";
        $orderversusname = $postprefix . "[" . LINKS_TAG_ORDERVERSUS . "]";
       
        $position_name = $postprefix . "[" . "position" . "]";
        $showlimit_name = $postprefix . "[" . "showlimit" . "]";

        $anchorname = $postprefix . "[" . "anchor" . "]";

 
        $visibilitylist_v = $postdata[LINKS_TAG_VISIBILITY_LIST];
        $orderby_v = $postdata[LINKS_TAG_ORDERBY];
        $orderversus_v = $postdata[LINKS_TAG_ORDERVERSUS];

        $tenda_visibility = $this->_make_tenda (
            array (
                LINKS_TAG_PRIVATE  => LINKS_TYPE_PRIVATE,
                LINKS_TAG_PUBLIC => LINKS_TYPE_PUBLIC
            ), LINKS_TAG_VISIBILITY, $visibility_default
        );

        $a_tipo_links = $this->_get_links_type_struct();


        $tenda_descpos = $this->_make_tenda (
            array (
                LINKS_TAG_INTEXT => LINKS_DESCPOS_TITLE,
                LINKS_TAG_DESCPOS_TOP => LINKS_DESCPOS_TOP,
                LINKS_TAG_DESCPOS_BOTTOM => LINKS_DESCPOS_BOTTOM,
                LINKS_TAG_DESCPOS_LEFT => LINKS_DESCPOS_LEFT,
                LINKS_TAG_DESCPOS_RIGHT => LINKS_DESCPOS_RIGHT,
                LINKS_TAG_DESCPOS_NO => LINKS_DESCPOS_NO
            ), FIELD_LINKS_DESCPOS, $descpos_default
        );

        $actionchange = "onchange=\"var itl = document.getElementById('idtipolink'); var ipl = document.getElementById('idpaglist'); iul = document.getElementById('idurl'); sts = itl.options[selectedIndex].text; if (sts.charAt(sts.length - 1) == 'I') { iul.disabled = true; ipl.disabled = false; } else { iul.disabled = false; ipl.disabled = true; }; \"";
        $idelem = "idtipolink";

        // $tenda_tipo = $this->_make_tenda ($a_tipo_links, "type", $type_default, "flinkadd", $actionchange, $idelem);
        $tenda_tipo = $this->_make_tenda ($a_tipo_links, "type", $type_default, "flinkadd", $actionchange, $idelem);

        $a_tipo_target = array (
            "" => "", 
            "_blank" => "blank",
            "_top" => "top",
            "_self" => "self",
            "_parent" => "parent"
        );
        $tenda_target = $this->_make_tenda ($a_tipo_target, "target", $target_default);


        $tenda_internal_node = $this->_output_page_list($currpageid, $pageid_is_disabled, $currpageid);

echo <<< END
        <form name="flinkadd" action="$_SERVER[PHP_SELF]" method="POST">
        $hidden_id_info
        <input type="HIDDEN" name="$visibilitylistname" value="$visibilitylist_v">
        <input type="HIDDEN" name="$orderbyname" value="$orderby_v">
        <input type="HIDDEN" name="$orderversusname" value="$orderversus_v">
        <input type="HIDDEN" name="$comefromname" value="$comefrom">
        <input type="HIDDEN" name="$position_name" value="$postdata[position]">
        <input type="HIDDEN" name="$showlimit_name" value="$postdata[showlimit]">

        <table class="table_border" width="
END;
        include(PRISCILLA_LOCAL_PATH . "adm/include/dim_all.inc.php");
        
echo <<< END
        " align="CENTER" cellpadding="3" cellspacing="1" border="0">

        <tr>
        <th colspan="3" class="table_tit" align="CENTER">
        $l_title
        </th>
        </tr>

        <tr>
        <td colspan="2" ALIGN ="CENTER" class="table_sez">
        $l_links_url:&nbsp;<input $s_url_disabled id="idurl" type="TEXT" value="$url_default" class="insert_area" size="25" maxlength="255" name="$urlname">&nbsp;$l_links_anchor:&nbsp;<input type="TEXT" value="$anchor_default" class="insert_area" size="10" maxlength="255" name="$anchorname">
        </td>
        <td align="CENTER" class="table_sez">
        $l_links_linktext:&nbsp;<input type="TEXT" value="$linktext_default" class="insert_area" size="40" maxlength="255" name="$linktextname">&nbsp;
        </td>
        <tr>
        <td  align="CENTER" class="table_sez">
        $l_links_visibility:&nbsp;$tenda_visibility
        </td>
        <td align="CENTER" class="table_sez">
        $l_links_target:&nbsp;$tenda_target
        </td> 
        <td align="CENTER" class="table_sez">
        $l_links_type:&nbsp;$tenda_tipo&nbsp;$tenda_internal_node
        </td>
        </tr>
        <tr>
        <td colspan="3" align="CENTER" class="table_sez">
        $l_links_description:&nbsp;<input type="TEXT" value="$description_default" class="insert_area" size="40" maxlength="255" name="$descname">&nbsp;
        $tenda_descpos
        </td>
        </tr>
        <td colspan="3" align="CENTER" class="button_out">
        <input type="SUBMIT" value="&nbsp;&nbsp;&nbsp;$b_links_action_do&nbsp;&nbsp;&nbsp;" name="$b_links_action_do_name" class="button_in awesome">
        $b_links_cancel_info
        </td>
        </tr>
        </table>
        </form>
END;

    }

    function outputConfigLinks($pd) {

        $l_title = LINKS_NO_SCRIPT;
        $b_links_save_prefs = LINKS_BUTTON_SAVE;


        $dbquery = "SELECT `nolinkscript` FROM `priscilla` WHERE `id` = 1 LIMIT 1";
        $rowrs = $this->_lk_connh->Execute($dbquery) or die("ERROR: $dbquery_t<br />" . $this->_lk_connh->ErrorMsg());

        if ($rowrs->fields('nolinkscript') == 'yes')
            $s_checked="checked";
        else
            $s_checked = "";

        echo <<< END
            <form name="flinksconfig" action="$_SERVER[PHP_SELF]" method="POST">
            <input type="HIDDEN" name="links[linkprefs]" value="1" />

        <table class="table_border" width="
END;

        include(PRISCILLA_LOCAL_PATH . "adm/include/dim_all.inc.php");
        
echo <<< END
        " align="CENTER" cellpadding="3" cellspacing="1" border="0">

        <tr>
        <th class="table_tit" align="CENTER">
        $l_title
        </th>
        </tr>

        <tr>
        <td ALIGN ="CENTER" class="table_sez">
        <input $s_checked type="checkbox" value="1" class="insert_area" name="links[nolinkscript]" id="nolinkscript" />
        </td>
        </tr>


        <tr>
        <td align="CENTER" class="button_out">
        <input type="SUBMIT" value="&nbsp;&nbsp;&nbsp;$b_links_save_prefs&nbsp;&nbsp;&nbsp;" name="links[bSavePrefs]" class="button_in awesome">
        </table>
        </form>
END;
    }

    function outputGroupPanel ($pd) {


        $postprefix = STATIC_MODULE_NAME;
        $nfield = 8 + 1;

        $l_links_title = LINKS_LINK_TYPE_TITLE;
    
        $l_links_id = FIELD_LINKS_ID;
        $l_links_name = LINKS_NAME;
        $l_links_tclass = LINKS_CLASS;
        $l_links_description = LINKS_DESCRIPTION;
        $l_links_imago = LINKS_IMAGE;
        $l_links_linkcounter = LINKS_LINK_CLICK_COUNT;
        $l_links_linktextclass = LINKS_TEXT_STYLE;
        $l_links_descriptionclass = LINKS_DESCRIPTION_STYLE;


        $comefromname = $postprefix . "[comefrom]";

        $cb_links_selected = $postprefix . "[idlist][]";


        $typename = $postprefix . "[type]";
        $descname = $postprefix . "[description]";
        $descclassname = $postprefix . "[descriptionclass]";
        $linktextclassname = $postprefix . "[linktextclass]";


        $b_links_remove = LINKS_LINK_TYPE_REMOVE;
        $b_links_modify = LINKS_LINK_TYPE_EDIT;
        $b_links_add = LINKS_LINK_TYPE_ADD;

        $b_name_remove = $postprefix . "[" . LINKS_BUTTON_TLINK_REMOVE . "]";
        $b_name_modify = $postprefix . "[" . LINKS_BUTTON_TLINK_MODIFY . "]";
        $b_name_add = $postprefix . "[" . LINKS_BUTTON_TLINK_ADD . "]";
        $group_button_name = $postprefix . "[" . LINKS_BUTTON_LINK_GROUPADMIN . "]";


        $b_links_action_cancel = LINKS_BUTTON_CANCEL;
        $b_links_action_cancel_name = $postprefix . "[" . LINKS_BUTTON_LINK_CANCEL . "]";

        $b_links_cancel_info = "&nbsp;&nbsp;<input type=\"SUBMIT\" value=\"&nbsp;&nbsp;&nbsp;$b_links_action_cancel&nbsp;&nbsp;&nbsp;\" name=\"$b_links_action_cancel_name\" class=\"button_in awesome\">&nbsp;&nbsp;";

 

        // modifica di un link preesistente
        if (isset($pd[LINKS_BUTTON_TLINK_MODIFY])) {

                     

            if (!($id = $this->_is_a_good_type($pd, $recinfo))) {
                $this->outError();
                return;                
            }
 
            $hiddenidname = $postprefix . "[" . FIELD_LINKS_ID . "]";
            $hidden_id_info="<input type=\"HIDDEN\" name=\"$hiddenidname\" value=\"$id\">";

            $typename_default = $recinfo[FIELD_LINKS_TYPE];
            $descname_default = $recinfo[FIELD_LINKS_DESCRIPTION];
            $tclass_default = $recinfo[FIELD_LINKS_TCLASS];
            $linkcounter_default = $recinfo[FIELD_LINKS_LINKCOUNTER];
            $linktextclass_default = $recinfo[FIELD_LINKS_LINKTEXTCLASS];
            $descriptionclass_default = $recinfo[FIELD_LINKS_DESCRIPTIONCLASS];

            $currimageid = $recinfo[FIELD_LINKS_IDIMAG];


            $b_links_action_do = LINKS_BUTTON_SAVE;
            $b_links_action_do_name = $postprefix . "[" . LINKS_BUTTON_TLINK_MODIFY_SAVE . "]";

            $button_list =
                "<input type=\"SUBMIT\" value=\"&nbsp;&nbsp;&nbsp;$b_links_action_do&nbsp;&nbsp;&nbsp;\" name=\"$b_links_action_do_name\" class=\"button_in awesome\">" .
                "&nbsp;&nbsp;&nbsp;" .
                $b_links_cancel_info;

        }
        // aggiunta di un nuovo tipo di link
        else {

            $hidden_id_info = "";

            $typename_default = "";
            $descname_default = "";
            $tclass_default = "";
            $linkcounter_default = "";
            $linktextclass_default = "linktstyle";
            $descriptionclass_default = "linkdstyle";

            $currimageid = 0;
            $button_list = 
                "<input type=\"SUBMIT\" value=\"&nbsp;&nbsp;&nbsp;$b_links_add&nbsp;&nbsp;&nbsp;\" name=\"$b_name_add\" class=\"button_in awesome\">" .
                "&nbsp;&nbsp;&nbsp;" .
                "<input type=\"SUBMIT\" value=\"&nbsp;&nbsp;&nbsp;$b_links_modify&nbsp;&nbsp;&nbsp;\" name=\"$b_name_modify\" class=\"button_in awesome\">" .
                "&nbsp;&nbsp;&nbsp;" .
                "<input type=\"SUBMIT\" value=\"&nbsp;&nbsp;&nbsp;$b_links_remove&nbsp;&nbsp;&nbsp;\" name=\"$b_name_remove\" class=\"button_in awesome\">";
        }

 

echo <<< END
        <form name="fgrouplist" action="$_SERVER[PHP_SELF]" method="POST">
        $hidden_id_info
        <input type="hidden" name="$group_button_name" value="1">
        <input type="hidden" name="$comefromname" value="grouplist">

        <table class="table_border" width="
END;
        include(PRISCILLA_LOCAL_PATH . "adm/include/dim_all.inc.php");
        
echo <<< END
        " align="CENTER" cellpadding="3" cellspacing="1" border="0">

        <tr>
        <th colspan="$nfield" class="table_tit" align="CENTER">
        $l_links_title
        </th>
        </tr>

        <tr>
        <td width="30" align="CENTER" class="table_tit">
        $l_links_id
        </td>
        <td align="CENTER" class="table_tit">
        $l_links_name
        </td>
        <td align="CENTER" class="table_tit">
        $l_links_tclass
        </td>
        <td  align="CENTER" class="table_tit">
        $l_links_description
        </td>
        <td align="CENTER" class="table_tit">
        $l_links_imago
        </td>
        <td align="CENTER" class="table_tit">
        $l_links_linkcounter
        </td>
        <td align="CENTER" class="table_tit">
        $l_links_linktextclass
        </td>
        <td align="CENTER" class="table_tit">
        $l_links_descriptionclass
        </td>
        <td align="CENTER" class="table_tit">
        &nbsp;
        </td>
        </tr>
END;


        $dbquery_t = "SELECT * FROM " . TABLE_LINKS_TYPE . " ORDER BY ID ASC";
        $rowrs = $this->_lk_connh->Execute($dbquery_t) or die("ERROR: $dbquery_t<br />" . $this->_lk_connh->ErrorMsg());

        // ciclo di stampa

        if (!$rowrs->RecordCount()) {
            echo $this->_output_message(LINKS_NO_LINK_TYPE);
        }
        else {
            while (!$rowrs->EOF) {

                $row = $rowrs->fields;

                $v_links_id = $row[FIELD_LINKS_ID];

                if ($row[FIELD_LINKS_TYPE] == LINKS_TAG_INTERNAL)
                    $v_links_type = LINKS_INTERNAL;
                else if  ($row[FIELD_LINKS_TYPE] == LINKS_TAG_EXTERNAL)
                    $v_links_type = LINKS_EXTERNAL;
                else
                    $v_links_type = $row[FIELD_LINKS_TYPE];


                $v_links_description = $row[FIELD_LINKS_DESCRIPTION];

                $idimag = $row[FIELD_LINKS_IDIMAG];

                $s_selected = "<input name=\"$cb_links_selected\" class=\"insert_area\" type=\"CHECKBOX\" value=\"$row[id]\">";

                if (is_numeric($idimag) && $idimag != 0) {

                    // si va a pescare il nome dell'immagine
                    $dbquery = "SELECT id_user, nome FROM immagini WHERE id_image = '$idimag'";
                    $imginfo = $this->_lk_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_lk_connh->ErrorMsg());

                    if ($imginfo->RecordCount() != 1)
                        $v_links_idimag = LINKS_STR_NOIMAG;
                    else {
                        $v_links_idimag = $imginfo->fields('nome');
                    }
                }
                else $v_links_idimag = LINKS_STR_NOIMAG;


                if ($row[FIELD_LINKS_ID] != 1 && $row[FIELD_LINKS_ID] != 2)
                    $v_delete_type = $s_selected;
                else
                    $v_delete_type = LINKS_STR_NOTYPEDELETE;

                $v_links_tclass = $row[FIELD_LINKS_TCLASS] == LINKS_TAG_EXTERNAL ? LINKS_EXTERNAL : LINKS_INTERNAL;
                $v_links_linkcounter = $row[FIELD_LINKS_LINKCOUNTER] == 'yes' ? LINKS_YES : LINKS_NO;
                $v_links_linktextclass = $row[FIELD_LINKS_LINKTEXTCLASS];
                $v_links_descriptionclass = $row[FIELD_LINKS_DESCRIPTIONCLASS];
                    
echo <<< END
                <tr>
                <td width="30" align="CENTER" class="table_id">
                $v_links_id
                </td>
                <td align="CENTER" class="table_sez">
                $v_links_type
                </td>
                <td align="CENTER" class="table_sez">
                $v_links_tclass
                </td>
                <td  align="CENTER" class="table_sez">
                $v_links_description
                </td>
                <td align="CENTER" class="table_sez">
                $v_links_idimag
                </td>
                <td align="CENTER" class="table_sez">
                $v_links_linkcounter
                </td>
                <td align="CENTER" class="table_sez">
                $v_links_linktextclass
                </td>
                <td align="CENTER" class="table_sez">
                $v_links_descriptionclass
                </td>
                <td align="CENTER" class="table_sez">
                $v_delete_type
                </td>
                </tr>
END;

                $rowrs->MoveNext();
            } // while
        }


        $tenda_imago = $this->_get_image_tenda($currimageid);
       
        $tenda_tclass = $this->_make_tenda (
            array (
                LINKS_TAG_EXTERNAL => LINKS_EXTERNAL,
                LINKS_TAG_INTERNAL => LINKS_INTERNAL
            ), FIELD_LINKS_TCLASS, $tclass_default
        );

        $tenda_linkcounter = $this->_make_tenda (
            array (
                "yes" => LINKS_YES,
                "no" => LINKS_NO, 
            ), FIELD_LINKS_LINKCOUNTER, $linkcounter_default
        );


echo <<< END

             <tr>
                <td width="30" align="CENTER" class="table_id">
                &nbsp;
                </td>
                <td align="CENTER" class="table_sez">
                <input class="insert_area" size="15" maxlength="255" type="TEXT" name="$typename" value="$typename_default">
                </td>
                <td align="CENTER" class="table_sez">
                $tenda_tclass
                </td>
                <td align="CENTER" class="table_sez">
                <textarea cols="20" rows="2" class="insert_area" maxlength="255" name="$descname">$descname_default</textarea>
                </td>
                <td align="CENTER" class="table_sez">
                $tenda_imago
                </td>
                <td align="CENTER" class="table_sez">
                $tenda_linkcounter
                </td>
                <td align="CENTER" class="table_sez">
                <input type="TEXT" value="$linktextclass_default" size="12" class="insert_area" maxlength="255" name="$linktextclassname">&nbsp;
                </td>
                <td align="CENTER" class="table_sez">
                <input type="TEXT" value="$descriptionclass_default" size="12" class="insert_area" maxlength="255" name="$descclassname">&nbsp;
                </td>
                <td align="CENTER" class="table_sez">
                &nbsp;
                </td>
                </tr>
                <tr>
                <td colspan="$nfield" align="CENTER" class="button_out">
                $button_list
                </td>
                </tr>

                </table>
                </form>
END;
        
        $this->_output_tomainpanel();

    } // outputGroupPanel


    // handling operazioni ////////////////////////////////////////////////////////
    function handleAddLink ($pd) {

        if ($this->_get_tclass($pd[FIELD_LINKS_TYPE]) == LINKS_TAG_INTERNAL && $pd[FIELD_LINKS_PAGEID] == 0) {
            $this->_lk_error = true;
            $this->_lk_last_error = LINKS_DEST_PAGE_CHOOSE;
            return;
        }

        $dbquery = "INSERT INTO " . TABLE_LINKS_LIST .
            " (" . FIELD_LINKS_URL . ", " .
                FIELD_LINKS_PAGEID . ", " .
                FIELD_LINKS_LINKTEXT . ", " .
                FIELD_LINKS_DESCRIPTION . ", " .
                FIELD_LINKS_DESCPOS . ", " .
                FIELD_LINKS_TYPE . ", " .
                FIELD_LINKS_TARGET . ", " .
                FIELD_LINKS_ANCHOR . ", " .
                FIELD_LINKS_VISIBILITY . ", " .
               FIELD_LINKS_OWNER . ")  " .
            " VALUES ('" . $pd[FIELD_LINKS_URL]  . "', " .
                "'" . $pd[FIELD_LINKS_PAGEID] . "', " .
                "'" . addslashes($pd[FIELD_LINKS_LINKTEXT]) . "', " .
                "'" . addslashes($pd[FIELD_LINKS_DESCRIPTION]) . "', " .
                "'" . $pd[FIELD_LINKS_DESCPOS] . "', " .
                "'" . $pd[FIELD_LINKS_TYPE] . "', " .
                "'" . $pd[FIELD_LINKS_TARGET] . "', " .
                "'" . $pd[FIELD_LINKS_ANCHOR] . "', " .
                "'" . $pd[FIELD_LINKS_VISIBILITY] . "', " .
                "'" . $this->_lk_user . "')";
               
        $this->_lk_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_lk_connh->ErrorMsg());

    } // handleAddLink


    function handleAddLinkType ($pd) {

        $typename = strtoupper(trim($pd[FIELD_LINKS_TYPE]));

        if (! $this->_is_a_good_typename($typename)) {
            $this->outError();
            return;
        }

        if ($this->_type_exists($typename)) {
            $this->_lk_error = true;
            $this->_lk_last_error = LINKS_TYPE_NAME_EXISTS . ": '" . $typename . "' ";
            return;
        }

        $dbquery = "INSERT INTO " . TABLE_LINKS_TYPE .
            " (" . FIELD_LINKS_TYPE . ", " .
                FIELD_LINKS_TCLASS . ", " .
                FIELD_LINKS_DESCRIPTION . ", " .
                FIELD_LINKS_LINKCOUNTER . ", " .
                FIELD_LINKS_DESCRIPTIONCLASS . ", " .
                FIELD_LINKS_LINKTEXTCLASS . ", "  . 
                FIELD_LINKS_IDIMAG . ") " .
            " VALUES ('" . $typename . "', " .
                "'" . $pd[FIELD_LINKS_TCLASS] . "', " .
                "'" . addslashes($pd[FIELD_LINKS_DESCRIPTION]) . "', " .
                "'" . $pd[FIELD_LINKS_LINKCOUNTER] . "', " .
                "'" . $pd[FIELD_LINKS_DESCRIPTIONCLASS] . "', " .
                "'" . $pd[FIELD_LINKS_LINKTEXTCLASS] . "', " . 
                "'" . $pd[FIELD_LINKS_IDIMAG] . "')";

        $this->_lk_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_lk_connh->ErrorMsg());

    } // handleAddLinkType


    function handleRemoveLink ($pd) {


        if (! ($id = $this->_is_a_good_id($pd, $recinfo))) {
            $this->outError();
            return;
        }

        $dbquery = "DELETE FROM " . TABLE_LINKS_LIST . " WHERE " . FIELD_LINKS_ID . " = '" . $id . "' LIMIT 1";
        $rowrs = $this->_lk_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_lk_connh->ErrorMsg());

    } // handleRemoveLink


    function handleRemoveLinkType ($pd) {

        if (! ($id = $this->_is_a_good_type ($pd, $recinfo))) {
            $this->outError();
            return;
        }

        $dbquery = "DELETE FROM " . TABLE_LINKS_TYPE . " WHERE " . FIELD_LINKS_ID . " = '" . $id . "' LIMIT 1";
        $rowrs = $this->_lk_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_lk_connh->ErrorMsg());

    } // handleRemoveLinkType


    function handleModifySaveLink ($pd) {

        $id = $pd[FIELD_LINKS_ID];

        if (!$this->_is_a_good_id($pd, $recinfo, $id)) {
            $this->outError();
            return;                
        }

	// toglobaloff

        // salva le modifiche
        $dbquery = "UPDATE " . TABLE_LINKS_LIST .
            " SET " . FIELD_LINKS_URL . " = '" . $pd[FIELD_LINKS_URL] . "', " .
                FIELD_LINKS_PAGEID . " = '" . $pd[FIELD_LINKS_PAGEID] . "', " .
                FIELD_LINKS_LINKTEXT . " = '" . addslashes($pd[FIELD_LINKS_LINKTEXT]) . "', " . 
                FIELD_LINKS_DESCRIPTION . " = '" . addslashes($pd[FIELD_LINKS_DESCRIPTION]) . "', "  .
                FIELD_LINKS_DESCPOS . " = '" . $pd[FIELD_LINKS_DESCPOS] . "', " .
                FIELD_LINKS_TYPE . " = '" . $pd[FIELD_LINKS_TYPE] . "', " .
                FIELD_LINKS_TARGET . " = '" . $pd[FIELD_LINKS_TARGET] . "', " .
                FIELD_LINKS_ANCHOR . " = '" . $pd[FIELD_LINKS_ANCHOR] . "', " .
                FIELD_LINKS_VISIBILITY . " = '" . $pd[FIELD_LINKS_VISIBILITY] . "' WHERE id = '$id'";

        $this->_lk_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_lk_connh->ErrorMsg());

    } // handleModifyLink


    function handleLinksNoScript ($pd) {

        if (isset($pd["nolinkscript"]))
            $v = "yes";
        else
            $v = "no";
       
        $dbquery = "UPDATE `priscilla` SET `nolinkscript` = '" . $v . "' WHERE `id` = 1 LIMIT 1";
        $this->_lk_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_lk_connh->ErrorMsg());

        $this->_output_tomainpanel();

        die ("</body>\n</html>\n");
    } // handleLinksNoScript

    function handleModifySaveLinkType ($pd) {
        
        $id = $pd[FIELD_LINKS_ID];


        if (!$this->_is_a_good_type($pd, $recinfo, $id)) {
            $this->outError();
            return;
        }

        $typename = strtoupper(trim($pd[FIELD_LINKS_TYPE]));

        if (! $this->_is_a_good_typename($typename)) {
            $this->outError();
            return;
        }

        if ($this->_type_exists($typename) && $typename != $recinfo[FIELD_LINKS_TYPE]) {
            $this->_lk_error = true;
            $this->_lk_last_error = LINKS_TYPE_NAME_EXISTS . ": '" . $typename . "' ";
            return;
        }

        // salva le modifiche
        $dbquery = "UPDATE " . TABLE_LINKS_TYPE .
            " SET " . FIELD_LINKS_TYPE . " = '" . $typename . "', " .
                FIELD_LINKS_TCLASS . " = '" . $pd[FIELD_LINKS_TCLASS] . "', " .
                FIELD_LINKS_DESCRIPTION . " = '" . addslashes($pd[FIELD_LINKS_DESCRIPTION]) . "', " .
                FIELD_LINKS_LINKCOUNTER . " = '" . $pd[FIELD_LINKS_LINKCOUNTER] . "', " .
                FIELD_LINKS_DESCRIPTIONCLASS . " = '" . $pd[FIELD_LINKS_DESCRIPTIONCLASS] . "', " .
                FIELD_LINKS_LINKTEXTCLASS . " = '" . $pd[FIELD_LINKS_LINKTEXTCLASS] . "', " .
                FIELD_LINKS_IDIMAG . " = '" . $pd[FIELD_LINKS_IDIMAG] . "' WHERE id = '$id'";

        $this->_lk_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_lk_connh->ErrorMsg());

        // si devono riportare anche le modifiche ai link che usano gia' questo tipo in caso di cambio nome

        if ($typename != $recinfo[FIELD_LINKS_TYPE]) {

            $dbquery = "UPDATE " . TABLE_LINKS_LIST . " SET " . FIELD_LINKS_TYPE . " = '" . $typename  . "'" .
                " WHERE " . FIELD_LINKS_TYPE . " = '" . $recinfo[FIELD_LINKS_TYPE] . "'";

            $this->_lk_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_lk_connh->ErrorMsg());
        }

    } // handleModifySaveLinkType


    function handleActionCancel ($pd) {

        $errmsg = LINKS_OPERATION_CANCELLED;
        $notemsg = ""; 

        $this->_output_error_message ($errmsg, $notemsg);
    } // handleActionCancel


    function outError() {

        if ($this->_lk_error == true) {
            $this->_lk_error = false;

            if ($this->_lk_last_error != '')
                $errmsg = $this->_lk_last_error;
            else
                $errmsg = "UNKNOWN ERROR";

            $this->_output_error_message ($errmsg, $notemsg);

            $this->_lk_last_error = '';
        }
    } // outError


} // class Links




?>
