<?
require_once "../../../adm/lib/setup.php";
require_once PRISCILLA_LOCAL_PATH."adm/lib/priscilla_session_init.inc.php";

// convert un colore da '#000000' ===> R,G,B
if (!function_exists('color_from_str')) {
    function color_from_str ($str, &$r, &$g, &$b) {
    
        if (strlen($str) != 7)
            return 0;
        if ($str{0} != '#')
            return 0;
    
        $r = base_convert(substr($str, 1, 2), 16, 10);
        $g = base_convert(substr($str, 3, 2), 16, 10);
        $b = base_convert(substr($str, 5, 2), 16, 10);
    
        if (($r < 0 || $r > 255) || ($g < 0 || $g > 255) || ($b < 0 || $b > 255))
            return 0;
    
    return 1;
    }
}

function make_captcha_image ($stext, $width, $height, $bg, $fg, $outfile = '') {
$JPEG_QUALITY = 100;

    $outimage = imagecreatetruecolor ($width, $height);

    // se i colori in ingresso passano come non buoni si va con quelli di default
    if (!color_from_str($bg, $r1, $g1, $b1))
        $bgc = imagecolorallocate($outimage, 255, 255, 255);
    else
        $bgc = imagecolorallocate($outimage, $r1, $g1, $b1);

    if (!color_from_str($fg, $r2, $g2, $b2))
        $fgc = imagecolorallocate($outimage, 0, 0, 0);
    else
        $fgc = imagecolorallocate($outimage, $r2, $g2, $b2);


    imagefilledrectangle($outimage, 0, 0, $width - 1, $height - 1, $bgc);
    imagerectangle($outimage, 0, 0, $width - 1, $height - 1, $fgc);

    $red = imagecolorallocatealpha($outimage, 255, 0, 0, 75);
    $green = imagecolorallocatealpha($outimage, 0, 255, 0, 75);
    $blue = imagecolorallocatealpha($outimage, 0, 0, 255, 75);

    $colors = array($red, $green, $blue);

    $prevx = 0;
    $font = imageloadfont('bubblebath.png');
    for ($i = 0; $i <= strlen($stext); $i++)
    {
        
        $textwidth = ImageFontWidth($font);
        $textheight = ImageFontHeight($font);

        $l = imagecreatetruecolor ($textwidth, $textheight);
        $fgc = imagecolorallocatealpha($l, 0, 0, 0, 0);
        $bgc = imagecolorallocatealpha($l, 255, 255, 255, 0);

        $bgc = imagecolortransparent($l, $bgc);
        imagefill($l, 0, 0, $bgc);

        $x = $textwidth * ($i + 1);
        $y = (($height - $textheight) / 2);
        
        $char_col = $colors[array_rand($colors)];
        imagechar ($l, $font, 0, 0, $stext{$i}, $char_col);

        if (function_exists('imagerotate'))
        {
            if (rand(1, 2) % 2) $l = imagerotate($l, rand(0, 15), $bgc);
            else $l = imagerotate($l, - rand(0, 15), $bgc);
        }

        $lw = imagesx($l);
        $lh = imagesy($l);

        $x = ($i == 0) ? 0 : $lw + $prevx;//(($width - $textwidth) / 2) + ;
        $prevx = $x;
        $y = ($height - $lh) / 2;
        imagecopymerge ($outimage, $l, $x, $y, 0, 0, $lw, $lh, 90);
    }

    // scelta di uno dei font predefiniti
    /*$font = 5;
    $textwidth = ImageFontWidth($font) * strlen($stext);
    $textheight = ImageFontHeight($font);

    imagestring ($outimage, $font, ($width - $textwidth) / 2, ($height - $textheight) / 2, $stext, $fgc);*/

    // Ellipses (helps prevent optical character recognition)
    imageellipse($outimage, rand(0, $width), rand(0, $height), 30, 30, $red);
    imageellipse($outimage, rand(0, $width), rand(0, $height), 30, 30, $green);
    imageellipse($outimage, rand(0, $width), rand(0, $height), 30, 30, $blue);
    imageellipse($outimage, rand(0, $width), rand(0, $height), 30, 30, $red);
    imageellipse($outimage, rand(0, $width), rand(0, $height), 30, 30, $green);
    imageellipse($outimage, rand(0, $width), rand(0, $height), 30, 30, $blue);
    $h = rand(0, $height);
    imageline($outimage, 0, $h, $width, $h, $red);
    $h = rand(0, $height);
    imageline($outimage, 0, $h, $width, $h, $green);
    $h = rand(0, $height);
    imageline($outimage, 0, $h, $width, $h, $blue);
    $w = rand(0, $width);
    imageline($outimage, $w, 0, $w, $height, $red);
    $w = rand(0, $width);
    imageline($outimage, $w, 0, $w, $height, $red);
    $w = rand(0, $width);
    imageline($outimage, $w, 0, $w, $height, $red);

    Header ('Last-Modified: '.gmdate('D, d M Y H:i:s', $timestamp).' GMT');
    Header('Content-Type: image/jpeg');
    imagejpeg($outimage, $outfile, $JPEG_QUALITY);
    imagedestroy($outimage);
}

make_captcha_image ($PRISCILLA_SESSION->getvalue('priscilla_img_code'), 200, 40, "#ffffff", "#000000");

?>