<?
/**
 * class security: superclasse di controllo livello
 * di sicurezza
 *
 * @package security
 */
class DataHandler
{
    var $obj;

    /**
     * ritorna una concreta istanza della classe
     *
     * @param string $dataHandler   Definisce il metodo di immagazzinare i dati
     *
     * @param array  $conf          Array chiave=>valore che contiene configurazioni
     *                              addizionali utili alle sottoclassi
     * @return boolean state        Ritorna lo stato dell'oggetto
     *
     * @access public
     */
    function &factory($dataHandler, $conf = array())
    {
        $dataHandler = strtolower($dataHandler);
        $class = $dataHandler;

        if (class_exists($class))
        {
            $obj =& new $class($conf);
            return $obj;
        }
        else false;

    }

    /**
     * ritorna una referenza all'istanza dell' oggetto, permette di avere piu' istanze nello
     * stesso oggetto
     *
     * @param string $dataHandler   Definisce il metodo di immagazzinare i dati
     *
     * @param array  $conf          Array chiave=>valore che contiene configurazioni
     *                              addizionali utili alle sottoclassi
     * @return array $instances     Ritorna un'array con chiave $signature dell'oggetto
     *                              e valore l'oggetto instanziato tramite il metodo factory
     *
     * @access public
     */
    function &singleton($dataHandler, $conf = array())
    {
        static $instances;
        if (!isset($instances)) $instances = array();

        $signature = serialize(array($dataHandler, $conf));
        if (!isset($instances[$signature]))
            $instances[$signature] = &DataHandler::factory($dataHandler, $conf);

        return $instances[$signature];
    }

    /**
     * ritorna una concreta istanza della classe
     *
     * @param string $dataHandler   Definisce il metodo di immagazzinare i dati
     *
     * @param array  $conf          Array chiave=>valore che contiene configurazioni
     *                              addizionali utili alle sottoclassi
     * @return boolean state        Ritorna lo stato dell'oggetto
     *
     * @access public
     */
    function DataHandler($dataHandler, $conf = array())
    {
        $obj = &DataHandler::factory($dataHandler, $conf);
        return $obj;
    }

    /**
     * implementazione astratta del metodo add
     */
    function add($itemname, $item)
    {
        return false;
    }

    /**
     * implementazione astratta del metodo remove
     */
    function remove ($itemname)
    {
        return false;
    }

    /**
     * implementazione astratta del metodo remove
     */
    function getvalue ($itemname)
    {
        return false;
    }

    /**
     * implementazione astratta del metodo exists
     */
    function exists ($itemname)
    {
        return false;
    }

    /**
     * implementazione astratta del metodo close
     */
    function close ()
    {
        return false;
    }

}

?>